#!/bin/bash

die() { echo "Error: $@"; exit 1; }

usage()
{
        echo "Usage:"
        echo "      $0"
        echo
        echo "The environment variables \$SSLCONFIG and \$SSLDIR will be respected too."
        echo
        die "No certificate name given!"
}

which openssl $> /dev/null || die "openssl not found!"
[[ $(id -u) -ne 0 ]] && die "You must be root!"
[ ! -d ${CERTDIR} ] && die "${CERTDIR} directory doesn't exist!"
[ ! -d ${KEYDIR} ] && die "${KEYDIR} directory doesn't exist!"
[ -f ${CERTFILE} ] && die "${CERTFILE} already exists, won't overwrite!"
[ -f ${KEYFILE} ] && die "${KEYFILE} already exists, won't overwrite!"

SSLDIR="${SSLDIR-/etc/ssl}"
SSLCONFIG="${SSLCONFIG-${SSLDIR}/openssl.cnf}"
CERTDIR="${SSLDIR}/certs"
KEYDIR="${SSLDIR}/private"
CERTNAME="mcore"
CERTFILE="${CERTDIR}/${CERTNAME}.pem"
KEYFILE="${KEYDIR}/${CERTNAME}.key"

openssl req -new -x509 -nodes -config ${SSLCONFIG} -out ${CERTFILE} -keyout ${KEYFILE} -days 365 || die "Certificate request failed!"
openssl x509 -subject -fingerprint -noout -in ${CERTFILE} || die "Fingerprint failed!"
